Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Public Attributes | List of all members
FltToEggConverter Class Reference

This class supervises the construction of an EggData structure from the data represented by the FltHeader. More...

`#include "fltToEggConverter.h"`

Inheritance diagram for FltToEggConverter:

## Public Member Functions
| FltToEggConverter (const FltToEggConverter &copy)
virtual bool | convert_file (const Filename &filename)
| Handles the reading of the input file and converting it to egg.
bool | convert_flt (const FltHeader *flt_header)
| Fills up the egg_data structure according to the indicated lwo structure.
virtual std::string | get_extension () const
| Returns the common extension of the file type this converter supports.
virtual DistanceUnit | get_input_units ()
| This may be called after convert_file() has been called and returned true, indicating a successful conversion.
virtual std::string | get_name () const
| Returns the English name of the file type this converter supports.
virtual SomethingToEggConverter * | make_copy ()
| Allocates and returns a new copy of the converter.
virtual bool | supports_compressed () const
| Returns true if this file type can transparently load compressed files (with a .pz extension), false otherwise.
Public Member Functions inherited from SomethingToEggConverter
| SomethingToEggConverter (const SomethingToEggConverter &copy)
void | clear_egg_data ()
| Sets the EggData to NULL and makes the converter invalid.
void | clear_end_frame ()
| Removes the value previously set by set_end_frame().
void | clear_error ()
| Resets the error flag to the no-error state.
void | clear_frame_inc ()
| Removes the value previously set by set_frame_inc().
void | clear_input_frame_rate ()
| Removes the value previously set by set_input_frame_rate().
void | clear_neutral_frame ()
| Removes the value previously set by set_neutral_frame().
void | clear_output_frame_rate ()
| Removes the value previously set by set_output_frame_rate().
void | clear_start_frame ()
| Removes the value previously set by set_start_frame().
Filename | convert_model_path (const Filename &orig_filename)
| Converts the indicated model filename to a relative or absolute or whatever filename, according to _path_replace.
virtual std::string | get_additional_extensions () const
| Returns a space-separated list of extension, in addition to the one returned by get_extension(), that are recognized by this converter.
AnimationConvert | get_animation_convert () const
| Returns how source animation will be converted into egg structures.
const std::string & | get_character_name () const
| Returns the name of the character generated.
EggData * | get_egg_data ()
| Returns the EggData structure.
double | get_end_frame () const
| Returns the value set by a previous call to set_end_frame().
double | get_frame_inc () const
| Returns the value set by a previous call to set_frame_inc().
double | get_input_frame_rate () const
| Returns the value set by a previous call to set_input_frame_rate().
bool | get_merge_externals () const
| Returns the current state of the merge_externals flag.
double | get_neutral_frame () const
| Returns the value set by a previous call to set_neutral_frame().
double | get_output_frame_rate () const
| Returns the value set by a previous call to set_output_frame_rate().
PathReplace * | get_path_replace ()
| Returns a pointer to the PathReplace object associated with this converter.
const PathReplace * | get_path_replace () const
| Returns a pointer to the PathReplace object associated with this converter.
double | get_start_frame () const
| Returns the value set by a previous call to set_start_frame().
bool | had_error () const
| Returns true if an error was detected during the conversion process (unless _allow_errors is true), false otherwise.
bool | handle_external_reference (EggGroupNode *egg_parent, const Filename &ref_filename)
| Handles an external reference in the source file.
bool | has_end_frame () const
| Returns true if the ending frame has been explicitly specified via set_end_frame(), or false if the ending frame should be implicit based on the source.
bool | has_frame_inc () const
| Returns true if the frame increment has been explicitly specified via set_frame_inc(), or false if the ending frame should be implicit based on the source.
bool | has_input_frame_rate () const
| Returns true if the frame rate has been explicitly specified via set_input_frame_rate(), or false otherwise.
bool | has_neutral_frame () const
| Returns true if the neutral frame has been explicitly specified via set_neutral_frame(), or false otherwise.
bool | has_output_frame_rate () const
| Returns true if the frame rate has been explicitly specified via set_output_frame_rate(), or false otherwise.
bool | has_start_frame () const
| Returns true if the starting frame has been explicitly specified via set_start_frame(), or false if the starting frame should be implicit based on the source.
virtual | PT (PandaNode) convert_to_node(const LoaderOptions &options
void | set_animation_convert (AnimationConvert animation_convert)
| Specifies how source animation will be converted into egg structures.
void | set_character_name (const std::string &character_name)
| Specifies the name of the character generated.
void | set_egg_data (EggData *egg_data)
| Sets the egg data that will be filled in when convert_file() is called.
void | set_end_frame (double end_frame)
| Specifies the ending frame of the animation to convert, in the units specified by set_input_frame_rate().
void | set_frame_inc (double frame_inc)
| Specifies the increment between frames to extract.
void | set_input_frame_rate (double input_frame_rate)
| Specifies the number of frames per second that is represented by the "frame" unit in the animation package.
void | set_merge_externals (bool merge_externals)
| Sets the merge_externals flag.
void | set_neutral_frame (double neutral_frame)
| Specifies the frame of animation to represent the neutral pose of the model.
void | set_output_frame_rate (double output_frame_rate)
| Specifies the number of frames per second that the resulting animation should be played at.
void | set_path_replace (PathReplace *path_replace)
| Replaces the PathReplace object (which specifies how to mangle paths from the source to the destination egg file) with a new one.
void | set_start_frame (double start_frame)
| Specifies the starting frame of the animation to convert, in the units specified by set_input_frame_rate().
virtual bool | supports_convert_to_node (const LoaderOptions &options) const
| Returns true if this converter can directly convert the model type to internal Panda memory structures, given the indicated options, or false otherwise.

## Public Attributes
bool | _compose_transforms
Public Attributes inherited from SomethingToEggConverter
bool | _allow_errors
virtual const Filename & | filename

## Additional Inherited Members
Static Public Member Functions inherited from SomethingToEggConverter
static double | get_default_frame_rate ()
| Returns the default frame rate if nothing is specified for input_frame_rate or output_frame_rate, and the animation package does not have an implicit frame rate.

## Detailed Description

This class supervises the construction of an EggData structure from the data represented by the FltHeader.

Reading and writing the egg and flt structures is left to the user.

Definition at line 49 of file fltToEggConverter.h.

## Constructor & Destructor Documentation

## ◆ FltToEggConverter() [1/2]

FltToEggConverter::FltToEggConverter | ( |  | ) |

Definition at line 44 of file fltToEggConverter.cxx.

## ◆ FltToEggConverter() [2/2]

FltToEggConverter::FltToEggConverter | ( | const FltToEggConverter & | copy | ) |

Definition at line 53 of file fltToEggConverter.cxx.

## ◆ ~FltToEggConverter()

FltToEggConverter::~FltToEggConverter | ( |  | ) |

Definition at line 63 of file fltToEggConverter.cxx.

## Member Function Documentation

## ◆ convert_file()

bool FltToEggConverter::convert_file | ( | const Filename & | filename | ) |
| virtual

Handles the reading of the input file and converting it to egg.

Returns true if successful, false otherwise.

This is designed to be as generic as possible, generally in support of run- time loading. Command-line converters may choose to use convert_flt() instead, as it provides more control.

Implements SomethingToEggConverter.

Definition at line 110 of file fltToEggConverter.cxx.

References convert_flt().

## ◆ convert_flt()

bool FltToEggConverter::convert_flt | ( | const FltHeader * | flt_header | ) |

Fills up the egg_data structure according to the indicated lwo structure.

Definition at line 142 of file fltToEggConverter.cxx.

References SomethingToEggConverter::clear_error(), and SomethingToEggConverter::had_error().

Referenced by convert_file().

## ◆ get_extension()

string FltToEggConverter::get_extension | ( |  | ) | const
| virtual

Returns the common extension of the file type this converter supports.

Implements SomethingToEggConverter.

Definition at line 88 of file fltToEggConverter.cxx.

## ◆ get_input_units()

DistanceUnit FltToEggConverter::get_input_units | ( |  | ) |
| virtual

This may be called after convert_file() has been called and returned true, indicating a successful conversion.

It will return the distance units represented by the converted egg file, if known, or DU_invalid if not known.

Reimplemented from SomethingToEggConverter.

Definition at line 134 of file fltToEggConverter.cxx.

## ◆ get_name()

string FltToEggConverter::get_name | ( |  | ) | const
| virtual

Returns the English name of the file type this converter supports.

Implements SomethingToEggConverter.

Definition at line 80 of file fltToEggConverter.cxx.

## ◆ make_copy()

SomethingToEggConverter * FltToEggConverter::make_copy | ( |  | ) |
| virtual

Allocates and returns a new copy of the converter.

Implements SomethingToEggConverter.

Definition at line 71 of file fltToEggConverter.cxx.

## ◆ supports_compressed()

bool FltToEggConverter::supports_compressed | ( |  | ) | const
| virtual

Returns true if this file type can transparently load compressed files (with a .pz extension), false otherwise.

Reimplemented from SomethingToEggConverter.

Definition at line 97 of file fltToEggConverter.cxx.

## Member Data Documentation

## ◆ _compose_transforms

bool FltToEggConverter::_compose_transforms

Definition at line 68 of file fltToEggConverter.h.

The documentation for this class was generated from the following files:

- pandatool/src/fltegg/fltToEggConverter.h
- pandatool/src/fltegg/fltToEggConverter.cxx